#!/usr/bin/perl
use strict;
use warnings;
use Cwd;

#Ce programme convertit une partie du fichier de sortie rasscf en fichier d'entrée pour molcas avec la numérotation adéquate.


#ouverture des fichiers d'entrée pour le singulet et le triplet
	open(my $input,  "<",  "$ARGV[0]")  or die "Can't open input: $!";
#ouverture du fichier de sortie
	open(my $out, ">",  "$ARGV[0].num_ddci") or die "Can't open output.txt: $!";

my $test=0;
my $nb_sym=1;
my $rule;
my @tableau;
my %tableau_reor = ();
my $current_working_directory = getcwd();
my $num_ligne=0;
my $num_atome=1;
my $i;my $j;my $k;
my $nb_elec=0;
my $prefix='';
while (<$input>) 
{ 
	#Lecture du nombre de symétries dans molcas
	if($num_ligne==0 &&/^\s*nb_sym\s*(\d)$/)
	{
		$nb_sym=$1;
		#print "$nb_sym \n";
	}

	#détection des numéros de chaque symétrie	
	$rule="\\s*Symmetry species"."\\s*(\\d)"x$nb_sym;
	#print $rule."\n";
	if($num_ligne==1 && /$rule/)
	{
		#La fonction split rajoute un blanc au début et à la fin
	 	#print join(':', split(/$rule/, $_)), "\n";
		@tableau=split(/$rule/, $_);
		for($i=0;$i<$nb_sym;$i++)
		{
			$tableau_reor{$i}{"Symétrie"}=$tableau[$i+1];
			#print $tableau_reor{$i}{"Symétrie"};
		}
	}

	#détection des étiquettes de symétrie	
	$rule="\\s*(\\w*)"x$nb_sym;
	#print $rule."\n";
	if($num_ligne==2 && /$rule/)
	{
		@tableau=split(/$rule/, $_);
		for($i=0;$i<$nb_sym;$i++)
		{
			$tableau_reor{$i}{"etiquette"}=$tableau[$i+1];
			#print $tableau_reor{$i}{"etiquette"};
		}
	}

	#détection des orbitales gelées	
	$rule="\\s*Frozen orbitals"."\\s*(\\d*)"x$nb_sym;
	if($num_ligne==3 && /$rule/)
	{
		@tableau=split(/$rule/, $_);
		for($i=0;$i<$nb_sym;$i++)
		{
			$tableau_reor{$i}{"frozen"}=$tableau[$i+1];
			#print $tableau_reor{$i}{"frozen"}."\n";
		}
	}

	#détection des orbitales inactives	
	$rule="\\s*Inactive orbitals"."\\s*(\\d*)"x$nb_sym;
	if($num_ligne==4 && /$rule/)
	{
		@tableau=split(/$rule/, $_);
		for($i=0;$i<$nb_sym;$i++)
		{
			$tableau_reor{$i}{"inactive"}=$tableau[$i+1];
			#print $tableau_reor{$i}{"inactive"}."\n";
		}
	}

	#détection des orbitales actives	
	$rule="\\s*Active orbitals"."\\s*(\\d*)"x$nb_sym;
	if($num_ligne==5 && /$rule/)
	{
		@tableau=split(/$rule/, $_);
		for($i=0;$i<$nb_sym;$i++)
		{
			$tableau_reor{$i}{"actives"}=$tableau[$i+1];
			#print $tableau_reor{$i}{"actives"}."\n";
		}
	}
	#détection des orbitales vacantes	
	$rule="\\s*Secondary orbitals"."\\s*(\\d*)"x$nb_sym;
	if($num_ligne==9 && /$rule/)
	{
		@tableau=split(/$rule/, $_);
		for($i=0;$i<$nb_sym;$i++)
		{
			$tableau_reor{$i}{"vacantes"}=$tableau[$i+1];
			#print $tableau_reor{$i}{"vacantes"}."\n";
		}
	}
	#détection des orbitales supprimées	
	$rule="\\s*Deleted orbitals"."\\s*(\\d*)"x$nb_sym;
	if($num_ligne==10 && /$rule/)
	{
		@tableau=split(/$rule/, $_);
		for($i=0;$i<$nb_sym;$i++)
		{
			$tableau_reor{$i}{"suppr"}=$tableau[$i+1];
			#print $tableau_reor{$i}{"suppr"}."\n";
		}
	}
	#détection du nb total d'orbitales	
	$rule="\\s*Number of basis functions"."\\s*(\\d*)"x$nb_sym;
	if($num_ligne==11 && /$rule/)
	{
		@tableau=split(/$rule/, $_);
		for($i=0;$i<$nb_sym;$i++)
		{
			$tableau_reor{$i}{"total"}=$tableau[$i+1];
			#print $tableau_reor{$i}{"total"}."\n";
		}
	}
	if($num_ligne==12 &&/^\s*nb_elec\s*(\d*)$/)
	{
		$nb_elec=$1;
		#print "$nb_elec \n";
	}	
	if($num_ligne==13 &&/^\s*prefix\s*(\w*)$/)
	{
		$prefix=$1;
		#print "$nb_elec \n";
	}	
	
	
$num_ligne++;
}


#Contrôle du nombre d'orbitales, il faut que la somme de tout les types d'orbitales soit égal au nombre total d'orbitales, si ce n'est pas le cas, le programme crashe.
$test=0;
for($i=0;$i<$nb_sym;$i++)
{
	$test+=$tableau_reor{$i}{"frozen"};
	$test+=$tableau_reor{$i}{"inactive"};	
	$test+=$tableau_reor{$i}{"actives"};	
	$test+=$tableau_reor{$i}{"vacantes"};
	$test+=$tableau_reor{$i}{"suppr"};		
	
	if($test != $tableau_reor{$i}{"total"}){die "Il y a une erreur dans le fichier d'entrée : le nombre total d'orbitales n'est pas égal à la somme des orbitales de chaque type"}
	$test=0;
}

#On s'arrange pour avoir un nombre d'électron pair puis on divise par deux pour que nombre d'orbitales actives dont on a besoin dans chaque symétrie soit OK 
#maintenant nborb_cas vaut le nombre d'orbitales nécessaire pour tout les électrons actifs.
my $nborb_cas=($nb_elec+$nb_elec%2)/2;;
my $num_orb=0;
my $nb_reste;
my $nborb_cas_2;


#On calcule les numéros des orbitales occupées, le programme rempli un maximum d'orbitale dans la symétrie 1 puis la symétrie deux etc..
for($i=0;$i<$nb_sym;$i++)
{
	$tableau_reor{$i}{"DDCI_fermi_occ"}='';
	$tableau_reor{$i}{"DDCI_fermi"}=0;
	$nb_reste=0;
	$tableau_reor{$i}{"DDCI_first_occ"}=$num_orb+1;
	$num_orb+=$tableau_reor{$i}{"inactive"};
	$tableau_reor{$i}{"DDCI_last_occ"}=$num_orb;
	for($j=1;$j<=$tableau_reor{$i}{"actives"};$j++)
	{
		if($nborb_cas>0)
		{
			$num_orb++;
			$nborb_cas--;
			$tableau_reor{$i}{"DDCI_fermi_occ"}.=$num_orb.',';
			$tableau_reor{$i}{"DDCI_fermi"}++;
		}
		else 
		{
			$nb_reste++;
		}
	}
	$tableau_reor{$i}{"CAS_reste"}=$nb_reste;
}


#On ajoute ensuite le nombre d'orbitales active nécessaire dans chaque symétrie en respectant les règles CASDI
for($i=0;$i<$nb_sym;$i++)
{
	$tableau_reor{$i}{"DDCI_fermi_vac"}='';
	while($tableau_reor{$i}{"CAS_reste"}>0)
	{
		$num_orb++;
		$tableau_reor{$i}{"CAS_reste"}--;
		$tableau_reor{$i}{"DDCI_fermi_vac"}.=$num_orb.',';
	}
	$tableau_reor{$i}{"DDCI_first_vac"}=$num_orb+1;
	$num_orb+=$tableau_reor{$i}{"vacantes"};
	$tableau_reor{$i}{"DDCI_last_vac"}=$num_orb;
}

#Affichage console pour la numérotation des orbitales.
for($i=0;$i<$nb_sym;$i++)
{
	print $tableau_reor{$i}{"Symétrie"}."\t".$tableau_reor{$i}{"etiquette"}."\t".$tableau_reor{$i}{"DDCI_first_occ"}."\t".$tableau_reor{$i}{"DDCI_last_occ"}."\t".$tableau_reor{$i}{"DDCI_fermi_occ"}."\t".$tableau_reor{$i}{"DDCI_fermi_vac"}."\t".$tableau_reor{$i}{"DDCI_first_vac"}."\t".$tableau_reor{$i}{"DDCI_last_vac"}."\n";
}	


#Affichage dans le fichier de sortie des symétries et des numéros d'orbitales.	
my $l_x;	
	print $out "Num sym Molcas"." "x(15-length("Num sym Molcas"));
for($i=0;$i<$nb_sym;$i++)
{
	$l_x=length($tableau_reor{$i}{"Symétrie"});
	print $out " "x(15-$l_x).$tableau_reor{$i}{"Symétrie"};
}
	print $out "\n";
print $out "Symétrie"." "x(16-length("Symétrie"));
for($i=0;$i<$nb_sym;$i++)
{
	$l_x=length($tableau_reor{$i}{"etiquette"});
	print $out " "x(15-$l_x).$tableau_reor{$i}{"etiquette"};
}
	print $out "\n";
	print $out "1st occ"." "x(15-length("1st occ"));
for($i=0;$i<$nb_sym;$i++)
{
	$l_x=length($tableau_reor{$i}{"DDCI_first_occ"});
	print $out " "x(15-$l_x).$tableau_reor{$i}{"DDCI_first_occ"};
}
	print $out "\n";
	print $out "last occ"." "x(15-length("last occ"));
	for($i=0;$i<$nb_sym;$i++)
{
	$l_x=length($tableau_reor{$i}{"DDCI_last_occ"});
	print $out " "x(15-$l_x).$tableau_reor{$i}{"DDCI_last_occ"};
}
	print $out "\n";
	print $out "Fermi occ"." "x(15-length("Fermi occ"));
	for($i=0;$i<$nb_sym;$i++)
{
	$l_x=length($tableau_reor{$i}{"DDCI_fermi_occ"});
	print $out " "x(15-$l_x).$tableau_reor{$i}{"DDCI_fermi_occ"};
}
	print $out "\n";
	print $out "Fermi vac"." "x(15-length("Fermi vac"));
	for($i=0;$i<$nb_sym;$i++)
{
	$l_x=length($tableau_reor{$i}{"DDCI_fermi_vac"});
	print $out " "x(15-$l_x).$tableau_reor{$i}{"DDCI_fermi_vac"};
}
	print $out "\n";
	print $out "1st vac"." "x(15-length("1st vac"));
	for($i=0;$i<$nb_sym;$i++)
{
	$l_x=length($tableau_reor{$i}{"DDCI_first_vac"});
	print $out " "x(15-$l_x).$tableau_reor{$i}{"DDCI_first_vac"};
}
	print $out "\n";
	print $out "last vac"." "x(15-length("last vac"));
	for($i=0;$i<$nb_sym;$i++)
{
	$l_x=length($tableau_reor{$i}{"DDCI_last_vac"});
	print $out " "x(15-$l_x).$tableau_reor{$i}{"DDCI_last_vac"};
}
	print $out "\n";
	
	
#Sortie DDCI correspondant aux données données en entrée.	
	
	print $out "#########################################\n";	
	print $out "###############SORTIE DDCI###############\n";
	print $out "#########################################\n";	
print $out "&cost\n";
print $out "prefix='$prefix.'	\n";

my $fermi_1;
my $fermi_2='';
for($i=0;$i<$nb_sym;$i++)
{
	$fermi_1=0;
	$fermi_1=$tableau_reor{$i}{"inactive"}+$tableau_reor{$i}{"DDCI_fermi"};
	$fermi_2.="$fermi_1,";
}

print $out "fermi=$fermi_2	\n";

my $frozen='';
for($i=0;$i<$nb_sym;$i++)
{
	$frozen.="$tableau_reor{$i}{'frozen'},";
}
print $out "frozen=$frozen	\n";
my $delete='';
for($i=0;$i<$nb_sym;$i++)
{
	$delete.="$tableau_reor{$i}{'suppr'},";
}
print $out "delete=$delete	\n";
print $out "molcas = 60\n";	
print $out "/\n\n";	

print $out "&molcs\n";
print $out "prefix='$prefix.'	\n";
print $out "fermi=$fermi_2	\n";
print $out "frozen=$frozen	\n";
print $out "delete=$delete	\n";
print $out "molcas = 60\n";	
print $out "/\n";	
print $out "&mcsfil prefix='$prefix.' /\n\n";

print $out "&cdfil prefix='$prefix.'   /\n";
print $out "&cd gener='CAS+DDCI-A REMPLIR',\n";

my $nborb_cas_2=0;
for($i=0;$i<$nb_sym;$i++)
{
	$nborb_cas_2+=$tableau_reor{$i}{'actives'};
}
print $out "noac=$nborb_cas_2,\n";

print $out "nelac=$nb_elec,\n";

my $numac='';
for($i=0;$i<$nb_sym;$i++)
{
	$numac.=$tableau_reor{$i}{'DDCI_fermi_occ'};
}
for($i=0;$i<$nb_sym;$i++)
{
	$numac.=$tableau_reor{$i}{'DDCI_fermi_vac'};
}
print $out "numac=$numac\n";
print $out "ms2=A REMPLIR,\n";
print $out "is0=A REMPLIR,\n";
print $out "/\n\n";	

print $out "&cdfil prefix='$prefix.'   /\n";
print $out "&dav nessai=0,\n";
print $out "nvec=A REMPLIR,\n";
print $out "twess = 0.001,\n";
print $out "iprec = 6,\n";
print $out "syspin = 'A REMPLIR',\n";
print $out "ywcas=T,\n";
print $out "NITER=50, /\n";
print $out "&ess file='A REMPLIR.ESS'\n";
print $out "/\n";	
print $out "&end\n";	
